struct StoredSectionInfoStruct
{
	DWORD dwBaseOnDisk;	//used for encrypting (in this program)
	DWORD dwBaseInMemory;	//base in memory (used when decrypting)
	DWORD dwSize;	//size on disk
};

struct PEHeaderDataStruct
{
	DWORD dwImageBase;
	DWORD dwImageSize;
	DWORD dwEntryPoint;
	DWORD dwNumberOfSections;
	DWORD dwSectionAlignment;
};

struct PackerDataStruct
{
	DWORD dwEncryptedSectionCount;
	bool bAntiDebug;
	bool bAntiDump;
	bool bRemovePe;
};

struct SectionDataStruct
{
	DWORD dwBase;
	DWORD dwSize;
	BYTE bEncryptionKey[0x36];
	BYTE bEncryptionKey2[0x36];
};

int DoPE(char *pOutFilename, bool bAntiDebug, bool bAntiDump, bool bAntiDisassemble, bool bRemoveRelocs, bool bRemovePe, bool bRemoveSegments, DWORD dwImageSize, IMAGE_NT_HEADERS *pNtHeader, DWORD dwFileSize);
extern void ClearAll();
extern void AddImportLog(char *pText);
extern HWND ghWndTestWindow;
extern void RedrawArea(HWND, int, int, int, int);
extern void *pDecryptData;
extern DWORD dwDecryptDataSize;
extern void *pEncryptData;
extern DWORD dwEncryptDataSize;
extern void GenEncryption();
bool bFirstLayer = false;
DWORD dwOrigVirtualAddress = 0;
DWORD dwOrigPtrRawData = 0;
DWORD dwOrigSizeRawData = 0;
DWORD dwTempBase = 0;
void (*pEncrypt)(DWORD dwKeyBase, DWORD dwKey2Base, DWORD dwKeyLen, DWORD dwDataBase, DWORD dwDataLen);
DWORD dwFakeSectionsCount = 0;
StoredSectionInfoStruct *pFakeSectionsInfo = NULL;
extern void *pImageData;

extern void AddLog(char*);
extern bool GetImportSel(int iIndex);

DWORD dwBaseOfPackerData = 0;
DWORD dwSizeOfPackerData = 0;
DWORD dwBaseOfPackerCode = 0;
DWORD dwSizeOfPackerCode = 0;
DWORD dwBaseOfImportData = 0;
DWORD dwSizeOfImportData = 0;
DWORD dwBaseOfNewImportData = 0;
DWORD dwSizeOfNewImportData = 0;
DWORD dwBaseOfNewImportPtrs = 0;
DWORD dwSizeOfNewImportPtrs = 0;
DWORD dwBaseOfRestoreImports = 0;
DWORD dwSizeOfRestoreImports = 0;
DWORD dwBaseOfSectionData = 0;
DWORD dwSizeOfSectionData = 0;
DWORD dwBaseOfDecryptionRoutine = 0;
DWORD dwSizeOfDecryptionRoutine = 0;
DWORD dwImportCount = 0;
DWORD dwRealImportDescriptorStart = 0;
char *pNewImportData = NULL;
char *pNewImportPtrs = NULL;
DWORD dwNewImportPtrsSize = 0;
DWORD dwNewImportDataSize = 0;
SectionDataStruct *pSectionData = NULL;

#define EXEDEFENDER_SIG 0xDA6E05B5

DWORD dwSizeToAllocate = 0;

extern void DoJunk(DWORD dwBase, DWORD dwMaxSize);

inline unsigned ALIGN_UP(unsigned a, unsigned b) { return ((a + b - 1) / b) * b; }
