/*
    This file is part of ExeDefender.

    ExeDefender is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ExeDefender is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ExeDefender.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <windows.h>

//Junk code generator

//1 byte
BYTE bJunkCode_1[] =
{
	0x90,
};

BYTE bJunkCode_2[] =
{
	0x57, 0x33, 0xFF, 0x8B, 0xF8, 0x33, 0xF9, 0x03, 0xFE, 0x33, 0xF7, 0x50, 0x03, 0xC3, 0x33, 0xF7, 0x8B, 0x7C, 0x24, 0x04, 0x8B, 0x04, 0x24, 0x83, 0xC4, 0x08
};

BYTE bJunkCode_3[] =
{
	0x33, 0xCF, 0x51, 0x8B, 0xCB, 0x03, 0xC8, 0x0B, 0xC8, 0x53, 0x8B, 0x4C, 0x24, 0x04, 0x83, 0xC4, 0x08, 0x8B, 0xFF, 0x33, 0xCF
};

BYTE bJunkCode_4[] =
{
	0x03, 0xFB, 0x83, 0xEC, 0x04, 0x89, 0x1C, 0x24, 0x5B, 0x2B, 0xFB
};

BYTE bJunkCode_5[] =
{
	0x50, 0x56, 0x8B, 0xC1, 0x03, 0x04, 0x24, 0x33, 0xF0, 0x33, 0xC0, 0x85, 0xC0, 0x03, 0xC7, 0x74, 0x00, 0x5E, 0x58
};

BYTE bJunkCode_6[] =
{
	0x3B, 0xC6, 0x03, 0xC7, 0x75, 0x0A, 0x50, 0x51, 0x39, 0x04, 0x24, 0x8B, 0xFF, 0x83, 0xC4, 0x08, 0x2B, 0xC7
};

//Base + 6 -> (dwRand)
//Base + 21 -> (dwRand ^ dwCrypt)
//Base + 26 -> (dwCrypt)
BYTE bJunkCode_7[] = 
{
	0x85, 0xDE, 0x75, 0x1D, 0x81, 0xC1, 0x44, 0x33, 0x22, 0x11, 0x51, 0x8B, 0xFF, 0x83, 0xC1, 0x04, 0x85, 0xC9, 0x59, 0x50, 0xB8, 0x11, 0x22, 0x33, 0x44, 0x35, 0x66, 0x77, 0x88, 0x99, 0x2B, 0xC8, 0x58, 0x8B, 0xFF
};

//Base + 4 -> (loop count DWORD)
BYTE bJunkCode_8[] = 
{
	0x51, 0x50, 0x53, 0xBB, 0x44, 0x33, 0x22, 0x11, 0x33, 0xC9, 0x03, 0xC7, 0x3B, 0x44, 0x24, 0x0C, 0x33, 0xC0, 0x41, 0x3B, 0xCB, 0x7C, 0xF3, 0x8B, 0xFF, 0x5B, 0x58, 0x59
};

BYTE bJunkCode_9[] = 
{
	0x03, 0xC1, 0x85, 0xC3, 0x2B, 0xC1
};

BYTE bJunkCode_10[] = 
{
	0x03, 0xD9, 0x51, 0x33, 0xC9, 0x03, 0xCF, 0x33, 0xCE, 0x2B, 0x1C, 0x24, 0x59
//	0x90
};

BYTE bJunkCode_11[] = 
{
	0x32, 0xC1, 0x83, 0xC7, 0x04, 0x3B, 0xF8, 0x74, 0x0E, 0x52, 0x23, 0xD0, 0x4A, 0x83, 0xEC, 0x04, 0x8B, 0x54, 0x24, 0x04, 0x83, 0xC4, 0x08, 0x32, 0xC1, 0x83, 0xEF, 0x04
};

BYTE bJunkCode_12[] = 
{
	0x85, 0xC0, 0x75, 0x02, 0x33, 0xC0, 0x8B, 0xFF
};

BYTE bJunkCode_13[] = 
{
	0x3B, 0xD0, 0x7D, 0x04, 0x40, 0x85, 0xC1, 0x48, 0x8B, 0xF6
};

//Base + 3 = dwRand (BYTE!)
BYTE bJunkCode_14[] = 
{
	0x50, 0xC1, 0xE8, 0x11, 0x48, 0x85, 0xC6, 0x58
};

BYTE bJunkCode_15[] = 
{
	0x50, 0xE8, 0x02, 0x00, 0x00, 0x00, 0xEB, 0x06, 0x85, 0x34, 0x24, 0x33, 0xC1, 0xC3, 0x58
};

//Base + 4 = dwRand (DWORD)
BYTE bJunkCode_16[] = 
{
	0x56, 0x50, 0x81, 0xCE, 0x44, 0x33, 0x22, 0x11, 0x3B, 0xF2, 0x33, 0xC0, 0x40, 0x85, 0xC0, 0x75, 0x02, 0x89, 0x07, 0x58, 0x5E
};

//Base + 2 = dwRand (BYTE), Base + 15 = same (BYTE) (((4 * i)))
BYTE bJunkCode_17[] = 
{
	0x83, 0xC4, 0x04, 0x33, 0x04, 0x24, 0x41, 0x3B, 0xC1, 0x49, 0x33, 0x04, 0x24, 0x83, 0xEC, 0x04
};

BYTE bJunkCode_18[] = 
{
	0x03, 0xF0, 0x56, 0x39, 0x3C, 0x24, 0x2B, 0xF0, 0x83, 0xC4, 0x04
};

BYTE bJunkCode_19[] = 
{
	0x8B, 0xF6, 0x3B, 0xF7
};

BYTE bJunkCode_20[] = 
{
	0x42, 0x85, 0xD6, 0x4A
};

BYTE bJunkCode_21[] = 
{
	0x53, 0x8B, 0xD8, 0x3B, 0xD9, 0x5B
};

BYTE bJunkCode_22[] = 
{
	0x50, 0x83, 0xC6, 0x04, 0x0F, 0xAF, 0xC6, 0x21, 0xD8, 0x58, 0x8B, 0xFF, 0x83, 0xEE, 0x04
};

BYTE bJunkCode_23[] = 
{
	0x40, 0x85, 0xC8, 0x48
};

BYTE bJunkCode_24[] = 
{
	0x85, 0xC0
};

BYTE bJunkCode_25[] = 
{
	0xE8, 0x00, 0x00, 0x00, 0x00, 0x83, 0x04, 0x24, 0x05, 0xC3
};

BYTE bJunkCode_26[] = 
{
	0x83, 0xEE, 0x04, 0x39, 0x34, 0x24, 0x83, 0xC6, 0x04
};

//+13 -> random byte (0 - 40)
BYTE bJunkCode_27[] =
{
	0x6A, 0x00, 0x89, 0x04, 0x24, 0x64, 0xA1, 0x00, 0x00, 0x00, 0x00, 0x83, 0xC0, 0x10, 0x58
};

BYTE bJunkCode_28[] = 
{
	0x53, 0x32, 0xD8, 0x50, 0x83, 0xC4, 0x04, 0x5B
};

DWORD AddJunk(DWORD dwBase, DWORD dwMaxSize)
{
	int iJunkCodeList[200];
	BYTE *pJunkCodeData[200];
	DWORD dwJunkCodeSize[200];
	int iValidJunkCount = 0;
	DWORD dwRand = 0;
	DWORD dwCrypt = 0;
	BYTE bRand = 0;

	memset((void*)&iJunkCodeList[0], 0, sizeof(iJunkCodeList));
	memset((void*)&pJunkCodeData[0], 0, sizeof(pJunkCodeData));
	memset((void*)&dwJunkCodeSize[0], 0, sizeof(dwJunkCodeSize));

	if(dwMaxSize >= sizeof(bJunkCode_1))
	{
		iJunkCodeList[iValidJunkCount] = 1;
		pJunkCodeData[iValidJunkCount] = bJunkCode_1;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_1);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_2))
	{
		iJunkCodeList[iValidJunkCount] = 2;
		pJunkCodeData[iValidJunkCount] = bJunkCode_2;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_2);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_3))
	{
		iJunkCodeList[iValidJunkCount] = 3;
		pJunkCodeData[iValidJunkCount] = bJunkCode_3;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_3);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_4))
	{
		iJunkCodeList[iValidJunkCount] = 4;
		pJunkCodeData[iValidJunkCount] = bJunkCode_4;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_4);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_5))
	{
		iJunkCodeList[iValidJunkCount] = 5;
		pJunkCodeData[iValidJunkCount] = bJunkCode_5;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_5);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_6))
	{
		iJunkCodeList[iValidJunkCount] = 6;
		pJunkCodeData[iValidJunkCount] = bJunkCode_6;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_6);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_7))
	{
		iJunkCodeList[iValidJunkCount] = 7;
		pJunkCodeData[iValidJunkCount] = bJunkCode_7;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_7);
		iValidJunkCount++;

		dwRand = rand();
		dwCrypt = rand();
		*(DWORD*)&bJunkCode_7[6] = dwRand;
		*(DWORD*)&bJunkCode_7[21] = dwRand ^ dwCrypt;
		*(DWORD*)&bJunkCode_7[26] = dwCrypt;
	}
	if(dwMaxSize >= sizeof(bJunkCode_8))
	{
		iJunkCodeList[iValidJunkCount] = 8;
		pJunkCodeData[iValidJunkCount] = bJunkCode_8;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_8);
		iValidJunkCount++;

		dwRand = ((DWORD)rand() % 0x50);
		*(DWORD*)&bJunkCode_8[4] = dwRand;
	}
	if(dwMaxSize >= sizeof(bJunkCode_9))
	{
		iJunkCodeList[iValidJunkCount] = 9;
		pJunkCodeData[iValidJunkCount] = bJunkCode_9;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_9);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_10))
	{
		iJunkCodeList[iValidJunkCount] = 10;
		pJunkCodeData[iValidJunkCount] = bJunkCode_10;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_10);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_11))
	{
		iJunkCodeList[iValidJunkCount] = 11;
		pJunkCodeData[iValidJunkCount] = bJunkCode_11;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_11);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_12))
	{
		iJunkCodeList[iValidJunkCount] = 12;
		pJunkCodeData[iValidJunkCount] = bJunkCode_12;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_12);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_13))
	{
		iJunkCodeList[iValidJunkCount] = 13;
		pJunkCodeData[iValidJunkCount] = bJunkCode_13;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_13);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_14))
	{
		iJunkCodeList[iValidJunkCount] = 14;
		pJunkCodeData[iValidJunkCount] = bJunkCode_14;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_14);
		iValidJunkCount++;

		bRand = (BYTE)(rand() % 30) + 1;
		*(BYTE*)&bJunkCode_14[3] = bRand;
	}
	if(dwMaxSize >= sizeof(bJunkCode_15))
	{
		iJunkCodeList[iValidJunkCount] = 15;
		pJunkCodeData[iValidJunkCount] = bJunkCode_15;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_15);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_16))
	{
		iJunkCodeList[iValidJunkCount] = 16;
		pJunkCodeData[iValidJunkCount] = bJunkCode_16;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_16);
		iValidJunkCount++;

		dwRand = rand();
		*(DWORD*)&bJunkCode_16[4] = dwRand;
	}
	if(dwMaxSize >= sizeof(bJunkCode_17))
	{
		iJunkCodeList[iValidJunkCount] = 17;
		pJunkCodeData[iValidJunkCount] = bJunkCode_17;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_17);
		iValidJunkCount++;

		bRand = (BYTE)(rand() % 12) + 4;
		*(BYTE*)&bJunkCode_17[2] = bRand;
		*(BYTE*)&bJunkCode_17[15] = bRand;
	}
	if(dwMaxSize >= sizeof(bJunkCode_18))
	{
		iJunkCodeList[iValidJunkCount] = 18;
		pJunkCodeData[iValidJunkCount] = bJunkCode_18;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_18);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_19))
	{
		iJunkCodeList[iValidJunkCount] = 19;
		pJunkCodeData[iValidJunkCount] = bJunkCode_19;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_19);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_20))
	{
		iJunkCodeList[iValidJunkCount] = 20;
		pJunkCodeData[iValidJunkCount] = bJunkCode_20;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_20);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_21))
	{
		iJunkCodeList[iValidJunkCount] = 21;
		pJunkCodeData[iValidJunkCount] = bJunkCode_21;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_21);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_22))
	{
		iJunkCodeList[iValidJunkCount] = 22;
		pJunkCodeData[iValidJunkCount] = bJunkCode_22;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_22);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_23))
	{
		iJunkCodeList[iValidJunkCount] = 23;
		pJunkCodeData[iValidJunkCount] = bJunkCode_23;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_23);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_24))
	{
		iJunkCodeList[iValidJunkCount] = 24;
		pJunkCodeData[iValidJunkCount] = bJunkCode_24;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_24);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_25))
	{
		iJunkCodeList[iValidJunkCount] = 25;
		pJunkCodeData[iValidJunkCount] = bJunkCode_25;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_25);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_26))
	{
		iJunkCodeList[iValidJunkCount] = 26;
		pJunkCodeData[iValidJunkCount] = bJunkCode_26;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_26);
		iValidJunkCount++;
	}
	if(dwMaxSize >= sizeof(bJunkCode_27))
	{
		iJunkCodeList[iValidJunkCount] = 27;
		pJunkCodeData[iValidJunkCount] = bJunkCode_27;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_27);
		iValidJunkCount++;

		bRand = (BYTE)(rand() % 40) + 1;
		*(BYTE*)&bJunkCode_27[13] = bRand;
	}
	if(dwMaxSize >= sizeof(bJunkCode_28))
	{
		iJunkCodeList[iValidJunkCount] = 28;
		pJunkCodeData[iValidJunkCount] = bJunkCode_28;
		dwJunkCodeSize[iValidJunkCount] = sizeof(bJunkCode_28);
		iValidJunkCount++;
	}

	DWORD dwId = (rand() % iValidJunkCount);
	memcpy((void*)dwBase, (void*)pJunkCodeData[dwId], dwJunkCodeSize[dwId]);

	return dwJunkCodeSize[dwId];
}

void DoJunk(DWORD dwBase, DWORD dwMaxSize)
{
	DWORD dwBytesRemaining = 0;
	DWORD dwBytes = 0;
	DWORD dwCurrAddr = 0;

	dwBytesRemaining = dwMaxSize;
	dwCurrAddr = dwBase;

	for(;;)
	{
		if(dwBytesRemaining == 0)
		{
			break;
		}

		dwBytes = AddJunk(dwCurrAddr, dwBytesRemaining);

		dwBytesRemaining -= dwBytes;
		dwCurrAddr += dwBytes;
	}
}
